=== debian/changelog ===
etlcpp (20.42.2+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Fri, 15 Aug 2025 13:22:09 -0700

etlcpp (20.42.1+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Thu, 17 Jul 2025 14:26:25 +0200
