=== debian/control ===
Source: etlcpp
Section: devel
Priority: optional
Build-Depends: debhelper (>= 11),
               python3-cogapp,
               doxygen,
               cmake,
               python3
Maintainer: Dima Kogan <dkogan@debian.org>
Standards-Version: 4.1.3
Homepage: http://www.etlcpp.org
Vcs-Git: https://salsa.debian.org/debian/etlcpp.git
Vcs-Browser: https://salsa.debian.org/debian/etlcpp

Package: libetlcpp-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Recommends: libetlcpp-doc
Description: Embedded Template Library: a C++ library for embedded applications
 ETL design objective covers the following areas:
 .
 - Create a set of containers where the size or maximum size is determined at
   compile-time.
 - These containers should be largely equivalent to those supplied in the STL,
   with a compatible API.
 - Be compatible with C++98 but implement as many of the later C++11/14/17
   additions as possible.
 - Have deterministic behaviour.
 - Add other useful components that are not present in the standard library.
 - The embedded template library has been designed for lower resource embedded
   applications. It defines a set of containers, algorithms, and utilities, some
   of which emulate parts of the STL. There is no dynamic memory allocation.
 - The library makes no use of the heap. All the containers (apart from
   intrusive types) have a fixed capacity allowing all memory allocation to be
   determined at compile-time. The library is intended for any compiler that
   supports C++03 or greater.
 .
 Development files

Package: libetlcpp-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Embedded Template Library: a C++ library for embedded applications
 ETL design objective covers the following areas:
 .
 - Create a set of containers where the size or maximum size is determined at
   compile-time.
 - These containers should be largely equivalent to those supplied in the STL,
   with a compatible API.
 - Be compatible with C++98 but implement as many of the later C++11/14/17
   additions as possible.
 - Have deterministic behaviour.
 - Add other useful components that are not present in the standard library.
 - The embedded template library has been designed for lower resource embedded
   applications. It defines a set of containers, algorithms, and utilities, some
   of which emulate parts of the STL. There is no dynamic memory allocation.
 - The library makes no use of the heap. All the containers (apart from
   intrusive types) have a fixed capacity allowing all memory allocation to be
   determined at compile-time. The library is intended for any compiler that
   supports C++03 or greater.
 .
 Documentation
