=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
dversionmangle=s/\+dfsg//g,\
repack,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/etlcpp-$1\.tar\.gz/ \
 https://github.com/ETLCPP/etl/tags .*/(\d\S+)\.tar\.gz
